Tweaked comment in last commit
[zfs-ubuntu/.git] / zfs-replicate-all
index c47b86f952930538361b488808ddf245e3fa46bf..62a0ce4d10f60a78cde674427c974341596c413a 100755 (executable)
@@ -50,6 +50,14 @@ cleanup_and_exit() {
 }
 trap cleanup_and_exit INT
 
+fatal_and_exit() {
+  # echo message to terminal
+  echo -e 2>&1 "$1"
+  # send email notification
+  echo -e "$1" | $mailx -s "zfs-replicate-all on $hostname failed" "$mailto"
+  exit 1
+}
+
 # This function executes the replicate command and checks the stoptime
 replicate() { 
   zfs-replicate $*  >> $logfile 2>&1
@@ -77,18 +85,16 @@ snapshot_age() {
   fi
 }
 
-# Mount the local backup pool if needed and the option is given to do so, else error out
+# Import the local backup pool if needed and the option is given to do so, else error out
 zpool list -H "$backup_pool" >/dev/null 2>&1
 if [ $? != 0 ]; then
   if [[ $import_export_backup_pool == 1 ]]; then
     zpool import $backup_pool
     if [ $? != 0 ]; then
-      echo "-E- unable to import the backup pool $backup_pool"
-      exit 1
+      fatal_and_exit "-E- unable to import the backup pool $backup_pool on $hostname" "$mailto"
     fi
   else 
-    echo "-E- The local backup pool, '$backup_pool' doesn't seem to exist." $mailto
-    exit 1
+    fatal_and_exit "-E- The local backup pool on $hostname, '$backup_pool' doesn't seem to exist." "$mailto"
   fi
 fi
 
@@ -96,8 +102,7 @@ fi
 backup_pool_guid=`zpool get guid $backup_pool 2>&1 | grep $backup_pool | awk '{ print $3 }'`
 zpool get guid $backup_pool > /dev/null 2>&1
 if [ $? != 0 ]; then
-  echo >&2 "-E- Unable to extract the guid for the local backup pool: $backup_pool"
-  exit 1
+  fatal_and_exit "-E- Unable to extract the guid for the local backup pool on $hostname: $backup_pool" "$mailto"
 fi
 
 # Setup our backup marker names
@@ -125,9 +130,13 @@ done
 
 # Export the local pool if told to do so
 if [[ $import_export_backup_pool == 1 ]]; then
-  zpool export $backup_pool
+  # Don't export the pool if there is a currently running zfs-scrub operation
+  ps -ef | grep -q "zfs-scrub ${backup_pool}" | grep -v grep
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- unable to export the local backup pool $backup_pool"
+    zpool export $backup_pool
+    if [ $? != 0 ]; then
+      fatal_and_exit "-E- unable to export the local backup pool $backup_pool on $hostname" "$mailto"
+    fi
   fi
 fi